package com.codvision.base.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.codvision.base.entity.SysNotice;
import com.codvision.base.entity.dto.SysNoticeDTO;
import com.codvision.base.entity.vo.SysNoticeVO;
import com.codvision.webcore.bean.QueryPage;
import com.codvision.webcore.service.IBaseService;

import java.util.List;

/**
 * <p>
 * 系统通知 服务类
 * </p>
 *
 * @author lingee
 * @since 2023-12-01
 */
public interface ISysNoticeService extends IBaseService<SysNotice, SysNoticeVO> {

    /**
     * 获取系统通知详情
     *
     * @param id
     * @return 系统通知
     */
    SysNoticeVO getDetail(Integer id);

    /**
     * 分页查询系统通知
     *
     * @param queryPage 分页参数
     * @return 分页结果
     */
    IPage<SysNoticeVO> getPageResult(QueryPage<SysNotice> queryPage);

    /**
     * 根据条件查询系统通知
     *
     * @param queryBean 查询条件
     * @return 系统通知列表
     */
    List<SysNoticeVO> listAll(SysNotice queryBean);

    /**
     * 新增保存系统通知
     *
     * @param sysNoticeDTO 通知信息
     */
    void saveSysNotice(SysNoticeDTO sysNoticeDTO);

    /**
     * 根据系统通知id列表删除系统通知
     *
     * @param ids 系统通知id列表
     */
    void deleteSysNotices(List<Integer> ids);

    /**
     * 发送通知
     *
     * @param sysNoticeDTO 系统通知
     */
    void send(SysNoticeDTO sysNoticeDTO);

    /**
     * 撤回通知
     *
     * @param sysNoticeDTO
     */
    void revoke(SysNoticeDTO sysNoticeDTO);

    /**
     * 根据用户id、类型分页查询
     *
     * @param uid  用户id
     * @param type 消息类型
     * @return 通知分页列表
     */
    IPage<SysNoticeVO> getListByUidAndType(IPage<SysNotice> page, Integer uid, Integer type);

    /**
     * 判断用户是否有未读的消息
     *
     * @param uid 用户id
     * @return 是or否
     */
    Boolean flagUnReadNotice(Integer uid);
}
